/**
 * Die Klasse realisiert einen dummen SpielHamster. Er nimmt immer abwechselnd 1
 * bzw. 2 Koerner.
 * 
 * @author Dietrich Boles (Universitaet Oldenburg)
 * @version 1.0 (28.01.2006)
 * 
 */
public class DummerSpielHamster extends SpielHamster {

	private int genommen; // speichert die Anzahl der genommen Koerner

	/**
	 * Konstruktor zum Erzeugen und Initialisieren eines Hamsters mit den
	 * uebergebenen Parametern
	 * 
	 * @param reihe
	 *            die Reihe des Territoriums, in der der Hamster erzeugt wird
	 * @param spalte
	 *            die Spalte des Territoriums, in der der Hamster erzeugt wird
	 * @param blickrichtung
	 *            die Richtung, in der der Hamster anfangs schaut (siehe
	 *            Konstanten)
	 * @param anzahlKoerner
	 *            die Anzahl an Koernern, die der Hamster anfangs im Maul hat
	 */
	public DummerSpielHamster(int reihe, int spalte, int blickrichtung,
			int koernerAnzahl) {
		super(reihe, spalte, blickrichtung, koernerAnzahl);
		this.genommen = 0;
	}

	/**
	 * die Methode zum Fressen; uebergeben wird, wie viele Koerner der Gegner
	 * gefressen hat; geliefert wird, wie viele Koerner der Hamster gefressen
	 * hat; der Hamster nimmt immer abwechselnd 1 bzw. 2 Koerner.
	 * 
	 * @param gegnerAnzahl
	 *            Anzahl der vom Gegner zuvor gefressenen Koerner
	 * @return Anzahl selbst gefressener Koerner
	 */
	public int naechsterSpielzug(int gegnerAnzahl) {
		this.laengeDerKornReihe = this.laengeDerKornReihe - gegnerAnzahl;

		// laufe wieder bis zum Anfang der Koernerreihe
		this.vor(gegnerAnzahl);

		// frisst immer abwechselnd 1 und 2 Koerner
		if (this.genommen == 1) {
			this.genommen = 2;
			this.vor();
			this.nimm();
			if (this.vornFrei()) {
				this.vor();
				this.nimm();
				this.laengeDerKornReihe = this.laengeDerKornReihe - 2;
				return 2;
			} else {
				this.laengeDerKornReihe = this.laengeDerKornReihe - 1;
				return 1;
			}
		} else {
			this.genommen = 1;
			this.vor();
			this.nimm();
			this.laengeDerKornReihe = this.laengeDerKornReihe - 1;
			return 1;
		}
	}
}
